From a5933f40be0f3d408bb920f296fb5119c3ec28f4 Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Fri, 30 Jan 2026 13:59:36 +0700
Subject: [PATCH v9 16/26] Fixing memory leak shown by valgrind

---
 src/bin/pgbench/pgbench.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 8eca537b718..466d9023d72 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -5357,6 +5357,8 @@ flushBuffer(PGconn *con, int16_t row_len)
 			PQputCopyData(con, (char *) bin_copy_buffer, bin_copy_buffer_length);
 		else
 			pg_fatal("It is NOT a COPY command that is currently running");
+
+		PQclear(res);
 		bin_copy_buffer_length = 0;
 	}
 }
@@ -5460,6 +5462,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	if (PQresultStatus(res) != PGRES_COPY_IN)
 		pg_fatal("unexpected copy in result: %s", PQerrorMessage(con));
+	PQclear(res);
 
 
 	sendBinaryCopyHeader(con);
@@ -5475,6 +5478,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 		PQputCopyData(con, (char *) bin_copy_buffer, bin_copy_buffer_length);
 	else
 		fprintf(stderr, "Unexpected mode %d instead of %d\n", PQresultStatus(res), PGRES_COPY_IN);
+	PQclear(res);
 
 
 	sendBinaryCopyTrailer(con);
@@ -5485,6 +5489,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 	{
 		if (PQputCopyEnd(con, NULL) == 1) /* success */
 		{
+			PQclear(res);
 			res = PQgetResult(con);
 			if (PQresultStatus(res) != PGRES_COMMAND_OK)
 				fprintf(stderr, "Error: %s\n", PQerrorMessage(con));
@@ -5492,7 +5497,6 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 		else
 			fprintf(stderr, "Error: %s\n", PQerrorMessage(con));
 	}
-
 	PQclear(res);
 }
 
-- 
2.43.0

